%%
% This code accompanies the paper:
% 
% "Point-wise Map Recovery and Refinement from Functional Correspondence"
% E. Rodola, M. Moeller, D. Cremers
% Proc. VMV 2015
%
% Please cite the paper above if you use this code in your research.
%
% Emanuele Rodola <emanuele.rodola@usi.ch>
% USI Lugano, July 2016
%
clear all
close all
clc

addpath('./cpd/')
addpath('./tools/')

k = 30;
max_iters = 10; % the more the better (but slower)

load('./data/tr_reg_079.mat');
load('./data/tr_reg_084.mat');

M.evecs = M.evecs(:,1:k);
M.evals = M.evals(1:k);

N.evecs = N.evecs(:,1:k);
N.evals = N.evals(1:k);

% load('./data/C1.mat')
load('./data/C2.mat')

matches = run_cpd(M, N, C, max_iters);

fprintf('Exact matches recovered: %.2f%%\n', 100*sum(M.gt==N.gt(matches))/M.n);

colors = create_colormap(N,N);
figure, colormap(colors(matches,:)), plot_scalar_map(M, 1:M.n)
figure, colormap(colors), plot_scalar_map(N, 1:N.n)
